import { AbstractCanvas, CanvasCfg, Point } from '@antv/g-base';
import { ChangeType } from '@antv/g-base';
import { IElement } from './interfaces';
import * as Shape from './shape';
import Group from './group';
declare class Canvas extends AbstractCanvas {
    constructor(cfg: CanvasCfg);
    isMiniNative(): boolean;
    isMini(): any;
    getDefaultCfg(): {
        visible: boolean;
        capture: boolean;
        zIndex: number;
    };
    /**
     * @protected
     * 初始化绑定的事件
     */
    initEvents(): void;
    registerEventCallback(e: any): void;
    /**
     * @protected
     * 清理所有的事件
     */
    clearEvents(): void;
    /**
     * 一些方法调用会引起画布变化
     * @param {ChangeType} changeType 改变的类型
     */
    onCanvasChange(changeType: ChangeType): void;
    getShapeBase(): typeof Shape;
    getGroupBase(): typeof Group;
    /**
     * 获取屏幕像素比
     */
    getPixelRatio(): number;
    getViewRange(): {
        minX: number;
        minY: number;
        maxX: any;
        maxY: any;
    };
    initDom(): void;
    createDom(): HTMLElement;
    setDOMSize(width: number, height: number): void;
    clear(): void;
    getShape(x: number, y: number): any;
    _getRefreshRegion(): any;
    _clearFrame(): void;
    draw(): void;
    _startDraw(): void;
    _drawRegion(): void;
    _drawAll(): void;
    skipDraw(): void;
    /**
     * 刷新图形元素，这里仅仅是放入队列，下次绘制时进行绘制
     * @param {IElement} element 图形元素
     */
    refreshElement(element: IElement): void;
    getPointByEvent(ev: Event): Point;
    getClientByEvent(event: any): any;
    getPointByClient(clientX: number, clientY: number): Point;
    getClientByPoint(x: number, y: number): Point;
}
export default Canvas;
