var cache = {};
export function setExtraFunction(extraData) {
    if (extraData === void 0) { extraData = {}; }
    cache['requestAnimationFrame'] = extraData['requestAnimationFrame'];
    cache['clearAnimationFrame'] = extraData['cancelAnimationFrame'];
}
function requestAnimationFrame(fn) {
    if (cache['requestAnimationFrame']) {
        return cache['requestAnimationFrame'](fn);
    }
    var method = typeof window === 'object' && window.requestAnimationFrame
        ? window.requestAnimationFrame
        : function (f) {
            return setTimeout(f, 16);
        };
    return method(fn);
}
function clearAnimationFrame(handler) {
    if (cache['clearAnimationFrame']) {
        return cache['clearAnimationFrame'](handler);
    }
    var method = typeof window === 'object' && window.cancelAnimationFrame ? window.cancelAnimationFrame : clearTimeout;
    return method(handler);
}
export { requestAnimationFrame, clearAnimationFrame };
//# sourceMappingURL=time.js.map