"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/***
 * 小程序canvas的handler，用于做兼容兜底
 */
var MiniCanvasProxy = /** @class */ (function () {
    function MiniCanvasProxy() {
    }
    MiniCanvasProxy.prototype.set = function (obj, prop, value) {
        switch (prop) {
            case 'strokeStyle':
                obj['setStrokeStyle'](value);
                break;
            case 'fillStyle':
                obj['setFillStyle'](value);
                break;
            case 'lineWidth':
                obj['setLineWidth'](value);
                break;
            case 'lineDash':
                obj['setLineDash'](value);
                break;
            case 'globalAlpha':
                if (value || value === 0) {
                    obj['globalAlpha'] = value;
                    obj['setGlobalAlpha'](value);
                }
                break;
            case 'fontSize':
                obj['setFontSize'](value);
                break;
            case 'textAlign':
                obj['setTextAlign'](value);
                break;
            case 'fontStyle':
            case 'font':
                obj['setFont'](value);
                break;
            case 'textBaseline':
                obj['setTextBaseline'](value);
                break;
            default:
                obj[prop] = value;
        }
        return true;
    };
    MiniCanvasProxy.prototype.get = function (obj, prop) {
        if (prop === 'globalAlpha' && obj[prop] === undefined)
            return 1;
        if (typeof obj[prop] === 'function') {
            return obj[prop].bind(obj);
        }
        return obj[prop];
    };
    return MiniCanvasProxy;
}());
exports.default = MiniCanvasProxy;
//# sourceMappingURL=mini-canvas-proxy.js.map