"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.clearAnimationFrame = exports.requestAnimationFrame = exports.setExtraFunction = void 0;
var cache = {};
function setExtraFunction(extraData) {
    if (extraData === void 0) { extraData = {}; }
    cache['requestAnimationFrame'] = extraData['requestAnimationFrame'];
    cache['clearAnimationFrame'] = extraData['cancelAnimationFrame'];
}
exports.setExtraFunction = setExtraFunction;
function requestAnimationFrame(fn) {
    if (cache['requestAnimationFrame']) {
        return cache['requestAnimationFrame'](fn);
    }
    var method = typeof window === 'object' && window.requestAnimationFrame
        ? window.requestAnimationFrame
        : function (f) {
            return setTimeout(f, 16);
        };
    return method(fn);
}
exports.requestAnimationFrame = requestAnimationFrame;
function clearAnimationFrame(handler) {
    if (cache['clearAnimationFrame']) {
        return cache['clearAnimationFrame'](handler);
    }
    var method = typeof window === 'object' && window.cancelAnimationFrame ? window.cancelAnimationFrame : clearTimeout;
    return method(handler);
}
exports.clearAnimationFrame = clearAnimationFrame;
//# sourceMappingURL=time.js.map